<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <suspense-query :query="courseQuery" :delay-loading="500" transition="page">
    <!-- Loading -->
    <template #loading>
      <page-loading />
    </template>

    <!-- Error -->
    <template #error>
      <page-error :error="courseError" />
    </template>

    <!-- Data -->
    <template #data>
      <!-- Handle potential subscription errors -->
      <suspense-mutation
        :mutation="subscriptionMutation"
        transition="slide-y-transition"
        transition-mode="out-in"
        :error-timeout="5000"
      >
        <!-- Error -->
        <template #error>
          <v-alert class="studium-alert" dense text type="error">
            {{ subscriptionMutationError.message }}
          </v-alert>
        </template>
      </suspense-mutation>

      <!-- Above tabs  -->
      <v-row no-gutters align="center" justify="space-between">
        <!-- Course details -->
        <v-col class="studium-hyphenate pb-2">
          <!-- Title -->
          <div class="studium-title--larger">{{ course.name }}</div>

          <!-- Instructors -->
          <div class="studium-subtitle">{{ courseInstructors }}</div>
        </v-col>

        <!-- Actions -->
        <v-col cols="auto">
          <!-- Small Screens -->
          <template v-if="$vuetify.breakpoint.xsOnly">
            <!-- Subscribe/unsubscribe -->
            <v-btn
              color="primary"
              icon
              large
              :ripple="false"
              :loading="subscriptionMutation.loading.value"
              @click="onSubscriptionClick"
            >
              <v-icon large> {{ course.subscribed ? 'mdi-star' : 'mdi-star-outline' }} </v-icon>
            </v-btn>
          </template>

          <!-- All other screens -->
          <template v-else>
            <!-- Subscribe/unsubscribe -->
            <v-btn
              class="studium-button mt-md-3"
              color="primary"
              text
              :ripple="false"
              :loading="subscriptionMutation.loading.value"
              @click="onSubscriptionClick"
            >
              {{ course.subscribed ? $t('courses.subscribed') : $t('courses.subscribe') }}
              <v-icon right medium> {{ course.subscribed ? 'mdi-star' : 'mdi-star-outline' }} </v-icon>
            </v-btn>
          </template>
        </v-col>
      </v-row>

      <!-- Tabs  -->
      <v-row class="mt-2" no-gutters>
        <v-col>
          <v-tabs v-model="tab" class="studium-tabs" background-color="transparent" color="primary">
            <!-- Tabs -->
            <v-tab class="studium-button" :ripple="false" to="description"> {{ $t('courses.description_t') }} </v-tab>
            <v-tab class="studium-button" :ripple="false" to="files"> {{ $t('courses.files_t') }} </v-tab>

            <!-- TODO: Think about future expansions of tabs, including: Statistics, FAQ, Forum, Bookstore, Career , ... -->
          </v-tabs>
        </v-col>
      </v-row>

      <!-- Below tabs  -->
      <v-tabs-items v-model="tab" class="fill-height">
        <!-- Description -->
        <v-tab-item class="fill-height" value="description">
          <course-description :course="course" />
        </v-tab-item>

        <!-- Files -->
        <v-tab-item class="fill-height" value="files">
          <course-files :course-code="course.code" />
        </v-tab-item>
      </v-tabs-items>
    </template>
  </suspense-query>
</template>

<script lang="ts">
import { computed, defineComponent, ref, useMeta, useRoute } from '@nuxtjs/composition-api'

import { useChangeCourseSubscriptionMutation, useCourseByCodeQuery } from '~/apollo/_generated'
import { subscriptionsUpdater } from '~/util/cache'
import { useErrorHandler } from '~/util/composables'

export default defineComponent({
  // Disable the page fade transition between tabs
  transition: 'none',
  setup(_, { root }) {
    const route = useRoute()

    // Current selected tab
    const tab = ref(route.value.params.tab || 'description')

    // Course query and data
    const courseQuery = useCourseByCodeQuery({ code: root.$route.params.code }) // TODO replace root.$router by useRouter() for reactivity (once dependencies are updated)
    const courseError = useErrorHandler(courseQuery)
    const course = computed(() => courseQuery.result.value?.courseByCode)

    // Course instructors
    // Convert list of instructors to comma seperated string
    const courseInstructors = computed(() => course.value?.instructor?.name)

    // Subscribe/unsubscribe to course mutation.
    const subscriptionMutation = useChangeCourseSubscriptionMutation({ update: subscriptionsUpdater })
    const subscriptionMutationError = useErrorHandler(subscriptionMutation)

    // SEO
    useMeta(() => ({
      title: course.value?.name || 'UGhent Course',
    }))

    // Event handler when the user clicks on the subscribe/unsubscribe button
    function onSubscriptionClick() {
      subscriptionMutation.mutate({ code: course.value?.code || '', value: !course.value?.subscribed })
    }

    return {
      tab,
      courseQuery,
      courseError,
      course,
      courseInstructors,
      subscriptionMutation,
      subscriptionMutationError,
      onSubscriptionClick,
    }
  },

  // Empty head for useMeta
  head: {},
})
</script>
